=== debian/changelog ===
onednn (3.7.2+ds-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: fix build vs host confusion (Closes: #1103803)

  [ Shengqi Chen ]
  * d/patches: cherry-pick patches from upstream version 3.7.3

 -- Shengqi Chen <harry@debian.org>  Wed, 23 Apr 2025 21:08:33 +0800

onednn (3.7.2+ds-1) unstable; urgency=medium

  * New upstream version 3.7.2+ds.
  * d/control: bump std-ver to 4.7.2 (no changes required).
  * Add patch to add basic build support on loong64 (closes: #1057643).
  * d/control: enable libdnnl{,-dev} on loong64.

 -- Shengqi Chen <harry@debian.org>  Tue, 08 Apr 2025 00:02:17 +0800
